 #####################################
###                                 ###
##          www.TheVWAP.com          ##
###                                 ###
 #####################################
##
##  TheVWAP_Boulevard_SCAN3 [v1.2]
##  code © Zach Hurwitz / idea credit to AllDayFaders (twtr: @team3dstocks)
##  June 14th, 2021
##
##  email:   Zach@TheVWAP.com  or  Support@TheVWAP.com
##  twitter: @ZachHurwitz      or  @TheVWAP
##  web:     www.TheVWAP.com   or  www.TheVWAP.com/vwap-boulevard/

def newDay = CompoundValue(1, GetYYYYMMDD() != GetYYYYMMDD()[1] and !IsNaN(close), yes);
def dateID = If(BarNumber() > 1, dateID[1] + newDay, 1); def isLast = IsNaN(close[-1]) and !IsNaN(close); def v = volume;
def vDay = volume(period = AggregationPeriod.DAY); def vwDay = vwap(period = AggregationPeriod.DAY); 
def barNo = BarNumber(); def maxBarNo = HighestAll(isLast * barNo); def NaN = Double.NaN;

script customGetMaxValueOffset {
    input Data = close;    input rangeStart = 25;    input rangeEnd = 0;
    def barNo = BarNumber();    def isLast = IsNaN(close[-1]) and !IsNaN(close);    def maxBarNo = HighestAll(isLast * barNo);
    def searchArray = If(Between(barNo, maxBarNo - rangeStart, maxBarNo - rangeEnd), Data, Double.NaN);    def maxValue = HighestAll(searchArray);
    def barNoOfMaxValue = HighestAll(If(searchArray == maxValue, barNo, Double.NaN));    plot offset = maxBarNo - barNoOfMaxValue;}

script customGetValue {
    input Data = close;    input offset = 0;
    def barNo = BarNumber();    def isLast = IsNaN(close[-1]) and !IsNaN(close);    def maxBarNo = HighestAll(isLast * barNo);
    def returnValue = HighestAll(If(barNo == maxBarNo - offset, Data, Double.NaN));    plot value = returnValue;}

def offset_1D = reference customGetMaxValueOffset(vDay, maxBarNo, 0) - 0;
def hiVal_1D = HighestAll(isLast * customGetValue(vDay, offset_1D)); def ID_1D = HighestAll(isLast * customGetValue(dateID, offset_1D));
def fuse_1De = CompoundValue(1, if dateID != ID_1D and dateID[1] == ID_1D then barNo else fuse_1De[1], Double.POSITIVE_INFINITY);

def vol_2D = CompoundValue(1, if (vDay > vol_2D[1] and vDay < hiVal_1D) then vDay else vol_2D[1], 0);
def hiVal_2D = HighestAll(isLast * vol_2D); def bar2 = CompoundValue(1, if vDay == hiVal_2D then barNo else bar2[1], vDay == hiVal_2D);
def offset_2D = maxBarNo - bar2; def ID_2D = HighestAll(isLast * customGetValue(dateID, offset_2D));
def fuse_2De = CompoundValue(1, if dateID != ID_2D and dateID[1] == ID_2D then barNo else fuse_2De[1], Double.POSITIVE_INFINITY);

def vol_3D = CompoundValue(1, if (vDay > vol_3D[1] and vDay < hiVal_2D) then vDay else vol_3D[1], 0);
def hiVal_3D = HighestAll(isLast * vol_3D); def bar3 = CompoundValue(1, if vDay == hiVal_3D then barNo else bar3[1], vDay == hiVal_3D);
def offset_3D = maxBarNo - bar3; def ID_3D = HighestAll(isLast * customGetValue(dateID, offset_3D));
def fuse_3De = CompoundValue(1, if dateID != ID_3D and dateID[1] == ID_3D then barNo else fuse_3De[1], Double.POSITIVE_INFINITY);

def rVWAP_1 = CompoundValue(1, if barNo >= fuse_1De then rVWAP_1[1] else vwap, NaN);
def rVWAP_2 = CompoundValue(1, if barNo >= fuse_2De then rVWAP_2[1] else vwap, NaN);
def rVWAP_3 = CompoundValue(1, if barNo >= fuse_3De then rVWAP_3[1] else vwap, NaN);

#input proximity_percent = 5;
#plot scan_proximity = Between(close, If(ContStat, cVW1, rVW1) * (1 - proximity_percent / 100), If(ContStat, cVW1, rVW1) * (1 + proximity_percent / 100));
plot scan_cross = close crosses rVWAP_1 or (close crosses rVWAP_2) or (close crosses rVWAP_3);
plot rVW1 = rVWAP_1; plot rVW2 = rVWAP_2; plot rVW3 = rVWAP_3;