 #####################################
###                                 ###
##          www.TheVWAP.com          ##
###                                 ###
 #####################################
##
##  TheVWAP_Boulevard_SCAN1 [v1.2]
##  code © Zach Hurwitz / idea credit to AllDayFaders (twtr: @team3dstocks)
##  June 14th, 2021
##
##  email:   Zach@TheVWAP.com  or  Support@TheVWAP.com
##  twitter: @ZachHurwitz      or  @TheVWAP
##  web:     www.TheVWAP.com   or  www.TheVWAP.com/vwap-boulevard/

def newDay = CompoundValue(1, GetYYYYMMDD() != GetYYYYMMDD()[1] and !IsNaN(close), yes);
def dateID = If(BarNumber() > 1, dateID[1] + newDay, 1); def isLast = IsNaN(close[-1]) and !IsNaN(close); def v = volume;
def vDay = volume(period = AggregationPeriod.DAY); def vwDay = vwap(period = AggregationPeriod.DAY); 
def barNo = BarNumber(); def maxBarNo = HighestAll(isLast * barNo); def NaN = Double.NaN;

script customGetMaxValueOffset {
    input Data = close;    input rangeStart = 25;    input rangeEnd = 0;
    def barNo = BarNumber();    def isLast = IsNaN(close[-1]) and !IsNaN(close);    def maxBarNo = HighestAll(isLast * barNo);
    def searchArray = If(Between(barNo, maxBarNo - rangeStart, maxBarNo - rangeEnd), Data, Double.NaN);    def maxValue = HighestAll(searchArray);
    def barNoOfMaxValue = HighestAll(If(searchArray == maxValue, barNo, Double.NaN));    plot offset = maxBarNo - barNoOfMaxValue;}

script customGetValue {
    input Data = close;    input offset = 0;
    def barNo = BarNumber();    def isLast = IsNaN(close[-1]) and !IsNaN(close);    def maxBarNo = HighestAll(isLast * barNo);
    def returnValue = HighestAll(If(barNo == maxBarNo - offset, Data, Double.NaN));    plot value = returnValue;}

def offset_1D = reference customGetMaxValueOffset(vDay, maxBarNo, 0) - 0;
def hiVal_1D = HighestAll(isLast * customGetValue(vDay, offset_1D)); def ID_1D = HighestAll(isLast * customGetValue(dateID, offset_1D));
def fuse_1De = CompoundValue(1, if dateID != ID_1D and dateID[1] == ID_1D then barNo else fuse_1De[1], Double.POSITIVE_INFINITY);
def rVWAP_1 = CompoundValue(1, if barNo >= fuse_1De then rVWAP_1[1] else vwap, NaN);

#input proximity_percent = 5;
#plot scan_proximity = Between(close, If(ContStat, cVW1, rVW1) * (1 - proximity_percent / 100), If(ContStat, cVW1, rVW1) * (1 + proximity_percent / 100));
plot scan_cross = close crosses rVWAP_1;
plot rVW1 = rVWAP_1;